# Wizard Template's Documentation

```{centered} _Let the wizard do the heavy lifting so you can focus on your craft_
```

::::{grid} 1 1 2 3
:class-container: text-center
:gutter: 3

:::{grid-item-card}
:link: getting-started/about
:link-type: doc
:class-header: bg-light

Project Management 🧙🏻‍♂️
^^^

This is a general-purpose template that aims to provide a magical start to any Python project.

:::

:::{grid-item-card}
:link: user-guide/tooling/index
:link-type: doc
:class-header: bg-light

Quality Assurance ✅
^^^

Use pre-commit hooks, linters, formatters, and unit tests to ensure your code is up to standard.

:::

:::{grid-item-card}
:link: user-guide/documentation
:link-type: doc
:class-header: bg-light

Documentation 📚
^^^

Write documentation with Jupyter Book, including API references, interactive tutorials, and more.

:::

:::{grid-item-card}
:link: user-guide/versioning-changelog
:link-type: doc
:class-header: bg-light

Versioning/Changelog 📜
^^^

Commitless versioning and changelog management with git tags, pull request labels and GitHub releases.
:::

:::{grid-item-card}
:link: user-guide/ci-cd
:link-type: doc
:class-header: bg-light

Automated CI/CD 🚀
^^^

Test, build, and publish your package to PyPi. Publish documentation to GitHub Pages.
:::

:::{grid-item-card}
:link: references/further-reading
:link-type: doc
:class-header: bg-light

Further Reading 📖
^^^

Resources and references to help you get the most out of this template.
:::

::::

This documentation is organized into a few major sections:

- **Getting Started** provides an overview of the project and how to set it up.
- **User Guide** contains details on how to use the template and the tools it provides.
- **Reference** section includes further reading, besides [API references](references/api-reference.rst) and [How to Contribute](references/how-to-contribute.md) guides that are ready to be used by any project built with this template.
